import * as Mc from "@minecraft/server"
import * as Ui from "@minecraft/server-ui"
const World = Mc.world
let max_health2
let try_open = 0
Mc.world.afterEvents.playerJoin.subscribe((eventData) => {
    try { Mc.world.getDimension('overworld').runCommandAsync(`scoreboard objectives add "unitx:ban" dummy`) } catch (e) { }
    default_settings()
})
/*World.beforeEvents.chatSend.subscribe((eventData) => {
    let { message, sender } = eventData
    if (World.getDynamicProperty("withdraw") == true) {
        if ((message.startsWith('!withdraw') || message.startsWith('!wd')) && !sender.hasTag('dead')) {
            eventData.cancel = true
        }
    }
    if (World.getDynamicProperty("!banned") == true && (message == '!banned' || message == '!bn')) {
        eventData.cancel = true
    }
    if (World.getDynamicProperty("!spectorors") == true && (message == '!spectorors' || message == '!sp')) {
        eventData.cancel = true
    }
    Mc.system.run(() => {
        if (World.getDynamicProperty("withdraw") == true) {
            if ((message.startsWith('!withdraw') || message.startsWith('!wd')) && !sender.hasTag('dead')) {
                let mes = message.replace(/\D/g, '')
                mes = parseInt(mes)
                mes = Math.round(mes)
                if (mes < 1) {
                    sender.sendMessage(`§cinvalid amount of hearts specified!`)
                    return
                }
                if (isNaN(mes)) { sender.sendMessage(`\§cInvaild syntax! §7Useage !wd 1-50`) }
                else {
                    let player = sender
                    getmax(player)
                    if (mes < (max_health2 / 2)) {
                        let mes2 = Math.floor(max_health2 / 2) - mes
                        try { player.triggerEvent(`unitx:health${mes2}`) } catch (e) { return }
                        player.runCommandAsync(`give @s unitx:heart ${mes}`)
                        sender.sendMessage(`§aYou have withdrawn §7${Math.round(mes)} §ahearts`)
                    }
                    else {
                        sender.sendMessage(`§cInsufficient amount of hearts gain more hearts to withdraw §7${mes} §chearts!`)
                    }
                }
            }
        }
        if (World.getDynamicProperty("!banned") == true && (message == '!banned' || message == '!bn')) {
            let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
            if (banned_players.length !== 0) {
                let names = undefined
                for (let i = 0; i < banned_players.length; i++) {
                    if (i == 0) names = banned_players[i].displayName.replace('banned:', '').replace(':end_select', '')
                    else names = names + "," + banned_players[i].displayName.replace(`banned: `).replace(`: end_select`)
                }
                if (names == undefined) sender.sendMessage(`§cNo banned players found!`)
                else sender.sendMessage(`§cBanned players: §7${names} `)
            }
            else {
                sender.sendMessage(`§cNo banned players found!`)
            }
        }
        if (World.getDynamicProperty("!spectorors") == true && (message == '!spectorors' || message == '!sp')) {
            const players = Array.from(World.getPlayers({ gameMode: "spectator" }), p => p.name)
            if (players.length == 0) {
                sender.sendMessage(`§cNo spectorors online!`)
                return
            }
            sender.sendMessage(`§cspectorors: §7${players} `)
        }
    })
})*/
Mc.world.afterEvents.entityLoad.subscribe((eventData) => {
    if (eventData.entity.hasTag('unitx:ban')) return
    let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
    if (banned_players.length !== 0) {
        let found = false
        for (let i = 0; i < banned_players.length; i++) {
            if (banned_players[i].displayName.includes("banned:" + eventData.entity.name + ":end_select")) {
                found = true
                break
            }
        }
        if (found == false) {
            eventData.entity.removeTag('unitx:ban')
            respawn_player(eventData.entity, false, false)
        }

    }

})
let delay = 100
Mc.system.run(async function tick() {
    Mc.system.run(tick)
    if (try_open > 0) try_open--
    if (delay > 0) delay--
    if (delay == 0) {
        if (Mc.world.scoreboard.getObjective('unitx:lifesteal_settings') == undefined) {
            default_settings()
            return
        }
        if (Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').getParticipants.length == 0) {
            default_settings()
            return
        }
    }
    if (delay == 0) {
        delay = 100
    }
    for (const player of Mc.world.getPlayers()) {
        if (player.hasTag('unitx:ban')) {
            let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
            if (banned_players.length !== 0) {
                let found = false
                for (let i = 0; i < banned_players.length; i++) {
                    if (banned_players[i].displayName.includes("banned:" + player.name + ":end_select")) {
                        player.runCommandAsync(`kick ${player.name} §cYou have lost your last life, You are banned!`)
                        found = true
                        break
                    }
                }
                //if (found == false) {
                //      player.removeTag('unitx:ban')
                //      respawn_player(player, false, false)
                //  }
            }
        }
        if (!(player.hasTag('starting_health'))) {
            if (get_saved_setting("random_hearts") == 1) {
                const ran = Math.floor(Math.random() * (get_saved_setting("max_random_hearts") - get_saved_setting("min_random_hearts")) + get_saved_setting("min_random_hearts"));
                player.triggerEvent(`unitx:health${ran}`)
                player.addTag('starting_health')
            }
            player.triggerEvent(`unitx:health${get_saved_setting("starting_health")}`)
            player.addTag('starting_health')
        }
        if ((player.getComponent('health').currentValue / 2) > get_saved_setting("max_health")) {
            player.triggerEvent(`unitx:health${Math.round(get_saved_setting("max_health"))}`)
        }
    }
})
/*Mc.world.beforeEvents.itemUseOn.subscribe((eventData) => {
    if (!eventData.block.permutation.matches('unitx:revive_beacon')) return
    if (eventData.itemStack.typeId !== 'unitx:revive_soul') return
    eventData.source.addTag('revive')
})*/
Mc.world.afterEvents.entityDie.subscribe((eventData) => {
    if (eventData.deadEntity.typeId !== 'minecraft:player') return
    if (get_saved_setting("environmental_deaths") == 0 && eventData.damageSource.damagingEntity == undefined) return
    if (get_saved_setting("environmental_deaths") == 0 && eventData.damageSource.damagingEntity.typeId !== 'minecraft:player') return
    getmax(eventData.deadEntity)
    if (Math.floor(max_health2 / 2) - get_saved_setting("health_lose") > 0) {
        let damager_type
        if (eventData.damageSource.damagingEntity == undefined) damager_type = undefined
        else damager_type = eventData.damageSource.damagingEntity.typeId

        if (get_saved_setting("environmental_deaths") == 0 && eventData.deadEntity.nameTag == eventData.damageSource.damagingEntity.nameTag) return
        if (get_saved_setting("environmental_deaths") == 0 && damager_type == "minecraft:player") {
            eventData.deadEntity.triggerEvent(`unitx:health${Math.floor(max_health2 / 2) - get_saved_setting("health_lose")}`)
        }
        if (get_saved_setting("environmental_deaths") == 1) {
            eventData.deadEntity.triggerEvent(`unitx:health${Math.floor(max_health2 / 2) - get_saved_setting("health_lose")}`)
        }
        if (eventData.damageSource.damagingEntity == undefined) return
        if (eventData.damageSource.damagingEntity == 'minecraft:player') return
        getmax(eventData.damageSource.damagingEntity)
        if ((get_saved_setting("health_gain") + (max_health2 / 2)) <= get_saved_setting("max_health")) {
            if (eventData.deadEntity.nameTag !== eventData.damageSource.damagingEntity.nameTag) {
                eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${Math.round(get_saved_setting("health_gain") + (max_health2 / 2))}`)
            }
        }
        else if ((get_saved_setting("health_gain") + (max_health2 / 2)) > get_saved_setting("max_health")) {
            if (eventData.deadEntity.nameTag !== eventData.damageSource.damagingEntity.nameTag) {
                eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${get_saved_setting("max_health")}`)
                eventData.damageSource.damagingEntity.sendMessage(`§cMax health reached!`)
            }
        }
    }
    else {
        if (get_saved_setting("drop_souls") == 1) {
            Mc.world.getDimension(eventData.deadEntity.dimension.id).spawnItem(new Mc.ItemStack("unitx:revive_soul", 1), { x: eventData.deadEntity.location.x, y: eventData.deadEntity.location.y, z: eventData.deadEntity.location.z })
        }
        eventData.deadEntity.triggerEvent(`unitx:health${get_saved_setting("starting_health")}`)
        if (get_saved_setting("after_last_life") == 1) {
            eventData.deadEntity.addTag("spectorator")
            eventData.deadEntity.runCommandAsync(`gamemode spectator @s`)
        }
        if (get_saved_setting("after_last_life") == 0) {
            eventData.deadEntity.addTag(`unitx:ban`)
            try { eventData.deadEntity.runCommandAsync(`scoreboard players add "banned:${eventData.deadEntity.name}:end_select" "unitx:ban" 0`) } catch (error) {
                eventData.deadEntity.runCommandAsync(`scoreboard objectives add "unitx:ban" dummy`)
                eventData.deadEntity.runCommandAsync(`scoreboard players add "banned:${eventData.deadEntity.name}:end_select" "unitx:ban" 0`)
            }
        }
    }
})
/*Mc.world.afterEvents.entityHurt.subscribe((eventData) => {
    if (eventData.hurtEntity.typeId !== "minecraft:player") return//runs if they don't die
    if (eventData.hurtEntity.getComponent('health').currentValue > 0) return
    getmax(eventData.hurtEntity)
    if (Math.floor(max_health2 / 2) - get_saved_setting("health_lose") > 0) {//runs if they can respawn after they are killed
        let damager_type
        if (eventData.damageSource.damagingEntity == undefined) damager_type = undefined
        else damager_type = eventData.damageSource.damagingEntity.typeId
        if (get_saved_setting("environmental_deaths") == 0 && damager_type == "minecraft:player") {
            eventData.hurtEntity.triggerEvent(`unitx:health${Math.floor(max_health2 / 2) - get_saved_setting("health_lose")}`)
        }
        if (get_saved_setting("environmental_deaths") == 1) {
            eventData.hurtEntity.triggerEvent(`unitx:health${Math.floor(max_health2 / 2) - get_saved_setting("health_lose")}`)
        }
    }
    
    else {//runs when they lose there last heart
        if (get_saved_setting("drop_souls") == 1) {
            eventData.hurtEntity.dimension.spawnItem(new Mc.ItemStack(Mc.ItemTypes.get("unitx:revive_soul")), new Mc.Vector(eventData.hurtEntity.location.x, eventData.hurtEntity.location.y, eventData.hurtEntity.location.z));
        }
        eventData.hurtEntity.triggerEvent(`unitx:health${ get_saved_setting("starting_health") } `)
        if (get_saved_setting("after_last_life") == 1) {
            eventData.hurtEntity.addTag("spectorator")
            eventData.hurtEntity.runCommandAsync(`gamemode spectator @s`)
        }
        if (get_saved_setting("after_last_life") == 0) {
            eventData.hurtEntity.addTag(`unitx: ban`)
            try { eventData.hurtEntity.runCommandAsync(`scoreboard players add "banned:${eventData.hurtEntity.name}:end_select" "unitx:ban" 0`) } catch (error) {
                eventData.hurtEntity.runCommandAsync(`scoreboard objectives add "unitx:ban" dummy`)
                eventData.hurtEntity.runCommandAsync(`scoreboard players add "banned:${eventData.hurtEntity.name}:end_select" "unitx:ban" 0`)
            }
        }

    if (eventData.damageSource.damagingEntity == undefined) return
    getmax(eventData.damageSource.damagingEntity)
    if ((get_saved_setting("health_gain") + (max_health2 / 2)) <= get_saved_setting("max_health")) {
        eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${Math.round(get_saved_setting("health_gain") + (max_health2 / 2))}`)
    }
    else if ((get_saved_setting("health_gain") + (max_health2 / 2)) > get_saved_setting("max_health")) {
        eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${get_saved_setting("max_health")} `)
        eventData.damageSource.damagingEntity.sendMessage(`§cMax health reached!`)
    }
})*/
function getmax(player) {
    let health1 = player.getComponent('minecraft:health').currentValue
    player.getComponent('minecraft:health').resetToMaxValue()
    max_health2 = player.getComponent('minecraft:health').currentValue
    player.getComponent('minecraft:health').setCurrentValue(health1)
}
/*World.afterEvents.worldInitialize.subscribe((eventData => {
    const dy = new Mc.DynamicPropertiesDefinition()
    dy.defineNumber("starting_health")
    dy.defineNumber("max_health")
    dy.defineNumber("health_gain")
    dy.defineNumber("health_lose")
    dy.defineBoolean("environmental_deaths")
    dy.defineBoolean("withdraw")
    dy.defineNumber("after_last_life")
    dy.defineBoolean("spectorors")
    dy.defineBoolean("banned")
    dy.defineNumber("respawn_hearts")
    dy.defineBoolean("drop_souls")
    dy.defineNumber("beacon_base")
    dy.defineBoolean("!banned")
    dy.defineBoolean("!spectorors")
    dy.defineBoolean("random hearts")
    dy.defineNumber("max random hearts")
    dy.defineNumber("min random hearts")
    eventData.propertyRegistry.registerWorldDynamicProperties(dy)
    if (World.getDynamicProperty("starting_health") == undefined) { World.setDynamicProperty("starting_health", 10) }
    if (World.getDynamicProperty("max_health") == undefined) { World.setDynamicProperty("max_health", 30) }
    if (World.getDynamicProperty("health_gain") == undefined) { World.setDynamicProperty("health_gain", 1) }
    if (World.getDynamicProperty("health_lose") == undefined) { World.setDynamicProperty("health_lose", 1) }
    if (World.getDynamicProperty("environmental_deaths") == undefined) { World.setDynamicProperty("environmental_deaths", true) }
    if (World.getDynamicProperty("withdraw") == undefined) { World.setDynamicProperty("withdraw", true) }
    if (World.getDynamicProperty("after_last_life") == undefined) { World.setDynamicProperty("after_last_life", 1) }
    if (World.getDynamicProperty("spectorors") == undefined) { World.setDynamicProperty("spectorors", false) }
    if (World.getDynamicProperty("banned") == undefined) { World.setDynamicProperty("banned", false) }
    if (World.getDynamicProperty("respawn_hearts") == undefined) { World.setDynamicProperty("respawn_hearts", World.getDynamicProperty("starting_health")) }
    if (World.getDynamicProperty("drop_souls") == undefined) { World.setDynamicProperty("drop_souls", true) }
    if (World.getDynamicProperty("beacon_base") == undefined) { World.setDynamicProperty("beacon_base", 1) }

    if (World.getDynamicProperty("!banned") == undefined) { World.setDynamicProperty("!banned", false) }
    if (World.getDynamicProperty("!spectorors") == undefined) { World.setDynamicProperty("!spectorors", false) }
    if (World.getDynamicProperty("random hearts") == undefined) { World.setDynamicProperty("random hearts", false) }

    if (World.getDynamicProperty("max random hearts") == undefined) { World.setDynamicProperty("max random hearts", 15) }
    if (World.getDynamicProperty("min random hearts") == undefined) { World.setDynamicProperty("min random hearts", 5) }
}))*/
Mc.world.beforeEvents.itemUseOn.subscribe((eventData) => {
    if (!eventData.block.permutation.matches('unitx:revive_beacon') || eventData.source.isSneaking == true) return
    if (try_open < 3) try_open++
    if (try_open > 1) return
    Mc.system.run(() => {
        let layer_read = get_saved_setting("beacon_base")
        for (let i = 0; i < layer_read; i++) {
            let block = eventData.block.location
            let blocks = blocksBetween(block.x - layer_read, block.y - layer_read, block.z - layer_read, block.x + layer_read, block.y - layer_read, block.z + layer_read)
            for (let i = 0; i < blocks.length; i++) {
                let block = Mc.world.getDimension(eventData.source.dimension.id).getBlock({ x: blocks[i][0], y: blocks[i][1], z: blocks[i][2] })
                if (!((block.permutation.matches("minecraft:gold_block")) || (block.permutation.matches("minecraft:iron_block")) || (block.permutation.matches("minecraft:diamond_block")) || (block.permutation.matches("minecraft:emerald_block")) || (block.permutation.matches("minecraft:netherite_block")))) {
                    eventData.source.sendMessage(`§cInvaild Beacon Base!`)
                    return
                }
            }
            layer_read--
        }
        let has = 0
        let inv = eventData.source.getComponent("minecraft:inventory").container
        for (let i = 0; i < inv.size; i++) {
            let item = inv.getItem(i)
            if (!item) continue
            if (item.typeId == "unitx:revive_soul") {
                has = 1
                break
            }
        }
        if (has == 0) eventData.source.sendMessage(`§cA soul is requred!`)
        if (has == 1) {
            let player = eventData.source
            let main = new Ui.ActionFormData()
            main.title('Reviving!')
            main.button('Reviving', "textures/blocks/deadbush")
            main.button('Unbaning', "textures/blocks/barrier")
            main.show(player).then((respond) => {
                if (respond.selection == 1) {
                    let ban = new Ui.ModalFormData()
                    ban.title('Unbanning players')
                    ban.textField('', 'Players name:')
                    ban.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
                        if (banned_players.length !== 0) {
                            let found = false
                            for (let i = 0; i < banned_players.length; i++) {
                                if (banned_players[i].displayName.includes("banned:" + respond.formValues[0] + ":end_select")) {
                                    try { player.runCommandAsync(`scoreboard players reset "banned:${respond.formValues[0]}:end_select" "unitx:ban"`) } catch (error) { }
                                    try {
                                        player.runCommandAsync(`clear @s unitx:revive_soul 0 1`)
                                        player.sendMessage(`§7Unbanned §a${respond.formValues[0]}`)
                                        player.runCommandAsync(`playsound ambient.weather.thunder @a`)
                                    } catch (error) { }
                                    found = true
                                    break
                                }
                            }
                            if (found == false) {
                                player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                                return
                            }
                        } else {
                            player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                            return
                        }
                    })
                }
                if (respond.selection == 0) {
                    let rev = new Ui.ModalFormData()
                    rev.title('Reviving')
                    const players = Array.from(Mc.world.getPlayers({ gameMode: "spectator" }), p => p.name)
                    const players_data = Array.from(World.getPlayers({ gameMode: "spectator" }))
                    if (players.length == 0) {
                        player.sendMessage(`§cNo died players online to revive!`)
                        return
                    }
                    rev.dropdown('Player to revive', players, 0)
                    rev.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        try {
                            player.runCommandAsync(`clear @s unitx:revive_soul 0 1`)
                        } catch (error) {
                            player.sendMessage(`§cA soul is requred!`)
                            return
                        }
                        let r = respond.formValues
                        players_data[r[0]].sendMessage(`§a${players[r[0]]} has been revived!`)
                        respawn_player(players_data[r[0]], false, true)
                        player.sendMessage(`§7You have revived §a${players[r[0]]}`)
                    })
                }
            })
        }
    })
})
Mc.world.afterEvents.playerBreakBlock.subscribe((eventData) => {
    if (eventData.block.typeId !== "unitx:revive_beacon") return
    let layer_read = get_saved_setting("beacon_base")
    for (let i = 0; i < get_saved_setting("beacon_base"); i++) {
        let blocks = blocksBetween(eventData.block.location.x - layer_read, eventData.block.location.y - layer_read, eventData.block.location.z - layer_read, eventData.block.location.x + layer_read, eventData.block.location.y - layer_read, eventData.block.location.z + layer_read)
        for (let i = 0; i < blocks.length; i++) {
            let block = World.getDimension("overworld").getBlock(new Mc.Vector(blocks[i][0], blocks[i][1], blocks[i][2])).typeId
            if (!((block == "minecraft:gold_block") || (block == "minecraft:iron_block") || (block == "minecraft:diamond_block") || (block == "minecraft:emerald_block") || (block == "minecraft:netherite_block"))) {
                return
            }
        }
        layer_read--
    }
    eventData.block.dimension.runCommandAsync(`playsound beacon.activate @a ${eventData.block.location.x} ${eventData.block.location.y} ${eventData.block.location.z} `)
})
function blocksBetween(x1, y1, z1, x2, y2, z2) {
    const locations = []
    for (let i = x1; i <= x2; i++) {
        for (let i2 = z1; i2 <= z2; i2++) {
            locations.push([i, y1, i2])
        }
    }
    return locations
}
Mc.world.afterEvents.itemUse.subscribe((eventData) => {
    if (eventData.itemStack.typeId == 'unitx:heart') {
        getmax(eventData.source)
        if ((max_health2 / 2) < get_saved_setting("max_health")) {
            eventData.source.triggerEvent(`unitx:health${Math.floor(max_health2 / 2) + 1}`)
            eventData.source.runCommandAsync(`clear @s unitx:heart -1 1`)
        }
        else eventData.source.sendMessage(`§cMax health reached!`)
    }
    if (eventData.itemStack.typeId == 'unitx:settings') {
        default_settings()
        let main = new Ui.ActionFormData()
        main.title('menu'),
            main.button('Settings', "textures/items/book_writable"),
            main.button('Reviving', "textures/blocks/deadbush"),
            main.button('Unbaning', "textures/blocks/barrier"),
            main.button('Credits', "textures/blocks/ender_chest_front")
        main.button('Extras', "textures/items/cake")
        let log_starting_health = get_saved_setting("starting_health")
        main.show(eventData.source).then((respond) => {
            if (respond.selection == 0) {
                let form = new Ui.ModalFormData()
                form.title('Settings')
                form.slider('Starting hearts', 1, 50, 1, get_saved_setting("starting_health"))
                form.slider('Max Hearts', 1, 50, 1, get_saved_setting("max_health"))
                form.slider('Hearts gained when you kill', 0, 25, 1, get_saved_setting("health_gain"))
                form.slider('Hearts lost when you die', 0, 25, 1, get_saved_setting("health_lose"))
                let toggle = false
                if (get_saved_setting("environmental_deaths") == 1) toggle = true
                form.toggle('You lose hearts anytime you die', toggle)
                //form.toggle('Enable !withdraw & !wd', get_saved_setting("withdraw"))
                toggle = false
                if (get_saved_setting("drop_souls") == 1) toggle = true
                form.toggle('Drop a soul when you lose your last heart', toggle)
                form.slider('Revive beacon base size needed', 0, 4, 1, get_saved_setting("beacon_base"))
                let res_hearts = get_saved_setting("starting_health")
                if (get_saved_setting("respawn_hearts") > -1) res_hearts = get_saved_setting("respawn_hearts")
                form.slider('Hearts given when Revived/Unbanned', 1, 50, 1, res_hearts)
                form.dropdown('when you lose your last heart', ['ban', 'spectator'], get_saved_setting("after_last_life"))
                form.show(eventData.source).then((respond) => {
                    if (respond.isCanceled) return;
                    let r = respond.formValues
                    set_saved_settings("starting_health", r[0])
                    set_saved_settings("max_health", r[1])
                    set_saved_settings("health_gain", r[2])
                    set_saved_settings("health_lose", r[3])
                    if (r[4] == true) set_saved_settings("environmental_deaths", 1)
                    if (r[4] == false) set_saved_settings("environmental_deaths", 0)
                    //  set_saved_settings("withdraw", r[5])
                    if (r[5] == true) set_saved_settings("drop_souls", 1)
                    if (r[5] == false) set_saved_settings("drop_souls", 0)
                    set_saved_settings("beacon_base", r[6])
                    if (!(r[7] == log_starting_health)) set_saved_settings("respawn_hearts", r[7])
                    set_saved_settings("after_last_life", r[8])
                })
            }
            if (respond.selection == 4) {
                let form = new Ui.ModalFormData()
                form.title('Settings')
                let toggle = false
                if (get_saved_setting("random_hearts") == 1) toggle = true
                form.toggle('Enable random starting hearts', toggle)
                form.slider('Max starting hearts', 1, 50, 1, get_saved_setting("max_random_hearts"))
                form.slider('Min starting hearts', 1, 50, 1, get_saved_setting("min_random_hearts"))
                // form.toggle('Enable !banned & !bn', get_saved_setting("!banned"))
                //  form.toggle('Enable !spectorors & !sp', get_saved_setting("!spectorors"))
                form.show(eventData.source).then((respond) => {
                    if (respond.isCanceled) return;
                    let r = respond.formValues
                    if (r[1] < r[2] && r[0] == true) {
                        eventData.source.sendMessage(`§cMaximum hearts can't be lower than Minimum hearts`)
                        return
                    }
                    if (r[0] == true) set_saved_settings("random_hearts", 1)
                    else set_saved_settings("random_hearts", 0)
                    set_saved_settings("max_random_hearts", r[1])
                    set_saved_settings("min_random_hearts", r[2])
                    //  set_saved_settings("!banned", r[3])
                    //  set_saved_settings("!spectorors", r[4])
                })
            }
            if (respond.selection == 3) {
                let credits = new Ui.ActionFormData()
                credits.title('Credits')
                credits.body('§7Made by §cUnitX\n\n§7Need help? §7Join my §9Discord\n§7https://discord.gg/krRXAdddgk\n\n§7Need a tutorial/info on settings? \n§cVist my youtube §7https://www.youtube.com/channel/UCUKB2Klf2Nkfi8reaxmdo0w')
                credits.button('§cClose')
                credits.show(eventData.source)
            }
            if (respond.selection == 1) {
                let rev = new Ui.ModalFormData()
                rev.title('Reviving')
                const players = Array.from(World.getPlayers({ gameMode: "spectator" }), p => p.name)
                const players_data = Array.from(World.getPlayers({ gameMode: "spectator" }))
                if (players.length == 0) {
                    eventData.source.sendMessage(`§cNo died players online to revive!`)
                    return
                }
                rev.dropdown('Player to revive', players, 0)
                rev.slider('Hearts', 1, 50, 1, get_saved_setting("respawn_hearts"))
                rev.show(eventData.source).then((respond) => {
                    if (respond.isCanceled) return;
                    let r = respond.formValues
                    respawn_player(players_data[r[0]], true, true)
                    players_data[r[0]].triggerEvent(`unitx:health${r[1]}`)
                    players_data[r[0]].sendMessage(`§a${players[r[0]]} has been revived!`)
                    eventData.source.sendMessage(`§7You have revived §a${players[r[0]]} §7with §c${r[1]} §7hearts`)
                })
            }
            if (respond.selection == 2) {
                let ban = new Ui.ModalFormData()
                ban.title('Unbanning players')
                ban.textField('', 'Players name:')
                ban.show(eventData.source).then((respond) => {
                    if (respond.isCanceled) return;
                    let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
                    if (banned_players.length == 0) {
                        eventData.source.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                    }
                    else {
                        for (let i = 0; i < banned_players.length; i++) {
                            if (!banned_players[i].displayName.includes("banned:" + respond.formValues[0] + ":end_select")) {
                                eventData.source.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                                continue
                            }
                            try { eventData.source.runCommandAsync(`scoreboard players reset "banned:${respond.formValues[0]}:end_select" "unitx:ban"`) } catch (error) { }
                            eventData.source.sendMessage(`§7Unbanned §a${respond.formValues[0]}`)
                            eventData.source.runCommandAsync(`playsound ambient.weather.thunder @a`)
                            break
                        }
                    }

                })
            }
        })
    }
})
let default_value_name = ['starting_health', 'max_health', 'health_gain', 'health_lose', 'environmental_deaths', 'after_last_life',
    'spectorors', 'banned', 'drop_souls', 'beacon_base', 'random_hearts', 'max_random_hearts', 'min_random_hearts', 'respawn_hearts']
let default_value = [10, 30, 1, 1, 1, 1, 0, 0, 1, 4, 0, 15, 5, -1]
function default_settings() {
    try { Mc.world.scoreboard.addObjective('unitx:lifesteal_settings', 'unitx:lifesteal_settings') } catch (e) { }
    for (let i = 0; i < default_value_name.length; i++) {
        try { if (Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').getScore(default_value_name[i]) == undefined) Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').setScore(`${default_value_name[i]}`, default_value[i]) } catch (e) {
            Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').setScore(`${default_value_name[i]}`, default_value[i])
        }
    }
}
function get_saved_setting(name) {
    return Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').getScore(name)
}
function set_saved_settings(name, score) {
    Mc.world.scoreboard.getObjective('unitx:lifesteal_settings').setScore(`${name}`, score)
}

function respawn_player(player, cus_heart, sound) {
    player.runCommandAsync(`gamemode s @s`)
    if (cus_heart == false) player.triggerEvent(`unitx:health${get_saved_setting("respawn_hearts")}`)
    if (sound == true) player.runCommandAsync(`playsound ambient.weather.thunder @a`)
    try { player.removeTag("spectorator") } catch (e) { }
    let spawnpoint = player.getSpawnPoint()
    let dimension
    try { dimension = spawnpoint.dimension } catch (e) { }
    if (spawnpoint == undefined) {
        dimension = Mc.world.getDimension('overworld')
        spawnpoint = Mc.world.getDefaultSpawnLocation()
    }
    player.teleport({ x: spawnpoint.x, y: spawnpoint.y, z: spawnpoint.z }, {
        dimension: dimension
    });
}